function NSAjax(url, method, async, parent){
	if (!method) method = "GET";
	if (!async) async = true;
	if (!parent) parent = {};
	
	this.url = url;
	this.method = method;
	this.async = async;
	
	this.request = new XMLHttpRequest();
	this.parent = parent;
	this.request.parent = this;
	
	try {
		this.request.open(this.method, this.url, this.async);		
	} catch (e) {
		this.logMessage("Error in opening request: " + this.url);
	}
	
	return this;
}

NSAjax.prototype.execute = function (callback) {
	var req = this.request;
	
	if (this.async){
		this.request.onreadystatechange = function (event) {
			if (req.readyState == 4){
				try {
					if (req.status == 200){
						callback(req.parent.parent, req);
					}
					else {
						req.parent.logMessage("Error in lookup status for URL " + req.parent.url + " ("+req.status+").");
					}
				} catch (e) {
					req.parent.logMessage("Error in determining Web service status for URL " + req.parent.url + ":" + e);
				}
			}
		};
	}
	
	try {
		this.request.send(null);
	} catch (e) {
		this.logMessage("Error in opening request: " + this.url);
	}
	
	if (!this.async){
		if (this.request.status == 200){
			callback(this.parent, this.request);
		}
		else {
			this.logMessage("Error in lookup status for URL " + this.url + " ("+this.request.status+").");
		}
	}
};

NSAjax.prototype.logMessage = function (message) {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage(message);
};