var NS_FAS = {
	domain : "http://www.netscape.com/",
	lookupUrl : "api/friendactivity",
	
	checkTimeoutId : null,
	
	currentAlerts : {
		comments : 0,
		stories : 0,
		votes : 0
	},
	
	prefs : null,
	prefBranch : "extensions.netscape.fas.",
	
	member : {
		alias : null
	},
	
	load : function () {
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(this.prefBranch);
		
		try {
			if (!window.opener && this.prefs.getBoolPref("showIntroduction")){
				window.openDialog("chrome://netscape-fas/content/intro.xul","netscape-fas-introduction","chrome=yes,left=400,top=300,dependent=yes,dialog=yes");
			}
		} catch (e) {
			this.prefs.setBoolPref("showIntroduction",true);
		}
		
		try {
			if (this.prefs.getBoolPref("firstRun")){
				setTimeout('NS_FAS.addToolbarButton();', 0);
				
				this.prefs.setBoolPref("firstRun", false);
			}
		} catch (e) {
			this.prefs.setBoolPref("firstRun", true);
		}
		
		this.checkTimeoutId = setTimeout('NS_FAS.checkActivity();',1000);
	},
	
	addToolbarButton : function () {
		if (!document.getElementById('netscape-fas-button')){
			// Determine which toolbar to place the icons onto
			if (document.getElementById("nav-bar").getAttribute("collapsed") != "true"){
				var toolbar = document.getElementById("nav-bar");
			}
			else {
				var toolbar = document.getElementById("toolbar-menubar");
			}
	
			var toolbox = document.getElementById("navigator-toolbox");
			var toolboxDocument = toolbox.ownerDocument;
		
			var currentSet = toolbar.currentSet;
			var newSet = currentSet;
			var setItems = currentSet.split(',');
			
			// Order of adding:
				// before netscape-sitemail-button
				// before urlbar-container
				// after home-button
				// after reload-button
				// after stop-button
				// after forward-button
				// before search-container
				// at the end

			if (this.utilities.getIndex(setItems, "netscape-sitemail-button") != -1){
				newSet = currentSet.replace("netscape-sitemail-button","netscape-fas-button,netscape-sitemail-button");
			}
			else if (this.utilities.getIndex(setItems, "urlbar-container") != -1){
				newSet = currentSet.replace("urlbar-container","netscape-fas-button,urlbar-container");
			}
			else if (this.utilities.getIndex(setItems, "home-button") != -1){
				newSet = currentSet.replace("home-button","home-button,netscape-fas-button");
			}
			else if (this.utilities.getIndex(setItems, "reload-button") != -1){
				newSet = currentSet.replace("reload-button","reload-button,netscape-fas-button");
			}
			else if (this.utilities.getIndex(setItems, "stop-button") != -1){
				newSet = currentSet.replace("stop-button","stop-button,netscape-fas-button");
			}
			else if (this.utilities.getIndex(setItems, "forward-button") != -1){
				newSet = currentSet.replace("forward-button","forward-button,netscape-fas-button");
			}
			else if (this.utilities.getIndex(setItems, "search-container") != -1){
				newSet = currentSet.replace("search-container","netscape-fas-button,search-container");
			}
			else {
				newSet += ",netscape-fas-button";
			}
			
			toolbar.currentSet = newSet;
			toolbar.setAttribute("currentset",newSet);
			
			toolboxDocument.persist(toolbar.id, "currentset");
			
			try {
				BrowserToolboxCustomizeDone(true)
			} catch (e) { }
		}
	},
	
	showLoginPrompt : function () {
		window.open("chrome://netscape-fas/content/loginPrompt.xul","loginPrompt", "chrome=yes,left=400,top=300,dependent=yes,dialog=yes");
	},
	
	checkActivity : function (checkingOnPageLoad) {
		clearTimeout(this.checkTimeoutId);
		
		function callaback(requester, request){
			var xml = request.responseXML;
				
			var member = xml.getElementsByTagName("member")[0];
			var loggedIn = parseInt(member.getAttribute("loggedIn"));
			
			if (!loggedIn){
				try {
					if (req.showPrompt && requester.prefs.getBoolPref("showLoginPrompt") && !window.opener){
						requester.showLoginPrompt();
					}
				} catch (e) { }
				
				if (document.getElementById("netscape-fas-button")){
					document.getElementById("netscape-fas-button").setAttribute("disabled","true");
					document.getElementById("netscape-fas-button").setAttribute("label","Activity");
					document.getElementById("netscape-fas-button").setAttribute("tooltiptext","You must be logged in to Netscape.com to use this feature.");
					document.getElementById("netscape-friends-activity-sidebar").setAttribute("disabled","true");
				}
				
				requester.member.alias = null;
			}
			else {
				requester.member.alias = member.getElementsByTagName("alias")[0].firstChild.nodeValue;
				
				requester.currentAlerts.stories = parseInt(xml.getElementsByTagName("stories")[0].getElementsByTagName("storycount")[0].firstChild.nodeValue);
				requester.currentAlerts.comments = parseInt(xml.getElementsByTagName("comments")[0].getElementsByTagName("commentcount")[0].firstChild.nodeValue);
				requester.currentAlerts.votes = parseInt(xml.getElementsByTagName("votes")[0].getElementsByTagName("votecount")[0].firstChild.nodeValue);
				
				if (document.getElementById("netscape-fas-button")){
					var notifications = 0;
					
					if (requester.prefs.getBoolPref("notifications.stories")) notifications += requester.currentAlerts.stories;
					if (requester.prefs.getBoolPref("notifications.comments")) notifications += requester.currentAlerts.comments;
					if (requester.prefs.getBoolPref("notifications.votes")) notifications += requester.currentAlerts.votes;
					
					if (notifications > 0){
						document.getElementById("netscape-fas-button").setAttribute("disabled","false");
						document.getElementById("netscape-fas-button").setAttribute("tooltiptext","View your Netscape friends' activity");
						document.getElementById("netscape-fas-button").setAttribute("label","Activity ("+notifications+")");
						document.getElementById("netscape-friends-activity-sidebar").setAttribute("disabled","false");
					}
					else {
						document.getElementById("netscape-fas-button").setAttribute("disabled","true");
						document.getElementById("netscape-fas-button").setAttribute("label","Activity");
						document.getElementById("netscape-fas-button").setAttribute("tooltiptext","No new friend activity");
						document.getElementById("netscape-friends-activity-sidebar").setAttribute("disabled","true");
					}
				}
				
				requester.checkTimeoutId = setTimeout('NS_FAS.checkActivity();',1000 * Math.max(1, requester.prefs.getIntPref("frequency")) * 60);
			}
		}

		if (document.getElementById("netscape-fas-button")){
			var config = "?";
			
			if (this.prefs.getBoolPref("notifications.stories")){
				config += 'stories=1&';
			}
			if (this.prefs.getBoolPref("notifications.comments")){
				config += 'comments=1&';
			}
			if (this.prefs.getBoolPref("notifications.votes")){
				config += 'votes=1';
			}
			
			var req = new NSAjax(this.domain + this.lookupUrl + config, "GET", true, this);
			req.showPrompt = true;
		
			if (checkingOnPageLoad) { req.showPrompt = false; }
		
			req.execute(callaback);
		}
		else {
			this.checkTimeoutId = setTimeout('NS_FAS.checkActivity();',1000 * Math.max(1, this.prefs.getIntPref("frequency")) * 60);
		}
	},
	
	openFriendsActivitySidebar : function () {
		var config = '?';
		
		if (this.prefs.getBoolPref("notifications.stories")){
			config += 'stories=1&';
		}
		if (this.prefs.getBoolPref("notifications.comments")){
			config += 'comments=1&';
		}
		if (this.prefs.getBoolPref("notifications.votes")){
			config += 'votes=1';
		}
		
		window.openWebPanel("Netscape Friends' Activity",this.domain + "member/" + this.member.alias + "/fas" + config);
		window.setTimeout('NS_FAS.checkActivity(true);',1000);
	},
	
	onPageLoad : function () {
		if (document.getElementById("netscape-fas-button")){
			// Check if the user is just logging in
			if (this.member.alias == null){
				var url = window.content.location.href;
				var pattern = "^" + this.domain + "$";
				var re = new RegExp(pattern, "i");
				
				if (url.match(re)){
					this.checkActivity(true);
				}
			}
		}
	},
	
	utilities : {
		launchUrl : function (url, event) {
			if ((event.which == 2) || (event.which == 1 && event.ctrlKey)){
				this.addTab(url);
			}
			else if (event.which == 1){
				this.inTab(url);
			}
		},
		
		addTab : function (url) {
			var browser = window.gBrowser || window.parent.gBrowser;
			var theTab = browser.addTab(url);
			browser.selectedTab = theTab;
		},
		
		inTab : function (url) {
			window.content.document.location.href = url;
		},
		
		getIndex : function (arr, val){
			for (var i = 0; i < arr.length; i++){
				if (arr[i] == val){
					return i;
				}
			}
			
			return -1;
		}
	}
};